/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.ljmu.metadata.schemasutilities;

import java.util.List;

import org.apache.log4j.Logger;
import org.dom4j.Document;
import org.dom4j.Node;


public class RdfVocabularyUtilities {
private static final Logger log = Logger.getLogger(RdfVocabularyUtilities.class);
	
	//RELS_EXT file management
	/**
	 * Search for a given property in an RDF file
	 * 
	 * @param propertyName
	 * @param xmlContents
	 * @return true if the element is present, otherwise false
	 */
	@SuppressWarnings("unchecked")
	public static boolean findRdfProperty(String propertyName, Document xmlDoc)
	{
		
		if (xmlDoc != null)	{
			String xPath = "//rdf:RDF/rdf:Description/*";

			List<Node> nodes = xmlDoc.selectNodes( xPath );
			for (Node node : nodes)	{
				if (node.getName().equals(propertyName))
					return true;
			}
			return false;
		} else	{
			log.info("Error while creating XML Document");
			return false;
		}
	}
}
