/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.ljmu.mulgaraifz.utilities;

public class Constants {
    /**
     * Mulgara base URI ends in '#' separator and then the graph names are appended
     */
    public static String GRAPH_SEPARATOR = "#";
    /**
     * Prefix used in Fedora for every identifier
     */
    public static final String INFO_FEDORA_PREFIX = "info:fedora/";
    /**
     * Used in Sparql Queries, when working with identifiers, URI come enclosed in '<' and '>'
     */
    public static final String ID_SEP_OPEN = "<";
    /**
     * Used in Sparql Queries, when working with identifiers, URI come enclosed in '<' and '>'
     */
    public static final String ID_SEP_CLOSE = ">";
    
    public static final String LIST_SEP = ";";
    public static final String URI_SEP = "/";
    public static final String NS_SEP = ":";
    public static final String URI_BEGIN = "<";
    public static final String URI_END = ">";
    
}
