/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.da.dext.genxml;

import java.util.List;
import java.util.Map;


public interface ElementsManagement {
    
    public String getCurrentDocumentPID();
    public void setCurrentDocumentPID(String currentDocumentPID);
    public String getCurrentDocumentXmlId();
    public void setCurrentDocumentXmlId(String currentDocumentXmlId);
    //Methods
    public List<?> getElementsList();
    public Object findElementByLabel(String name);
    public Object findElementByDisplayLabel(String name);
    public void constructListOfElements(String language);
    public String getDocumentXmlId(String elementLabel, String documentPid);
    public String searchDocumentIds(String documentPid);
    public void clearList();
    public boolean generateElementsMap(String valueElement, String labelElement);
    public Map<?, ?> getElementsMap();
    public void setElementsMap(Map<?, ?> map);
    public void setElementsList(List<?> ellist);
    //AMG Added to update the QuDEx categories or codes elements
    //public void updateQudexElement();
}
