/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.da.dext;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import uk.da.dext.datastructs.CategoryStruct;
import uk.da.dext.genxml.CategoryManagement;
import uk.da.dext.genxml.ElementsManagement;

public class Main {

	/**
	 * @param args
	 */
	@SuppressWarnings("unchecked")
	public static void main(String[] args) {
		ElementsManagement catManager = new CategoryManagement();
		Map<String, String> myMap = new HashMap<String, String>();
		myMap.put("Sex Category", "Sex");
		myMap.put("Female", "Sex:Female");
		myMap.put("Male", "Sex:Male");
		myMap.put("Work status", "work");
		myMap.put("employed", "work:employed");
		myMap.put("unemployed", "work:unemployed");
		myMap.put("Female employed", "work:employed:Female");
		catManager.setElementsMap(myMap);
		catManager.constructListOfElements("EN-GB");
		for (CategoryStruct cat : (List<CategoryStruct>) catManager.getElementsList()) {
			System.out.println("Cat display label: " + cat.getCategoryDisplayLabel());
			System.out.println("Cat label: " + cat.getCategoryLabel());
			System.out.println("Cat children: " + cat.getImmChildren());
			System.out.println("Cat parents: " + cat.getImmParents());
		}
	}

}
