/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.ljmu.qudex.qudexservlet.servlets;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.json.JSONObject;
import net.sf.json.JSONSerializer;

public class ReceiveJsonServlet  extends HttpServlet {
	/**
	 * 
	 */
	private static final long serialVersionUID = 4654079226694285L;

	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		String type = (String) req.getParameter("type");
		JSONObject jsonCollections = null;
		if (type == null) {	
			jsonCollections = (JSONObject) JSONSerializer.toJSON((String) req.getParameter("collections"));
			req.setAttribute("collections", jsonCollections);
		}
		JSONObject jsonFiles = (JSONObject) JSONSerializer.toJSON((String) req.getParameter("files"));
		req.setAttribute("files", jsonFiles);
		req.setAttribute("col-index", (String) req.getParameter("colIdx"));
		
		JSONObject jsonCategories = (JSONObject) JSONSerializer.toJSON((String) req.getParameter("cats"));
		req.setAttribute("cats", jsonCategories);
		
		if (type == null) {
			RequestDispatcher requestDispatcher =  req.getRequestDispatcher("graph.vm");
			requestDispatcher.forward(req, resp);
		} else {
			RequestDispatcher requestDispatcher =  req.getRequestDispatcher("graph-file.vm");
			requestDispatcher.forward(req, resp);
		}
	}

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		doGet(req, resp);
	}

}
