/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.ljmu.qudexapps.xmllib.main;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
//import java.util.ArrayList;
//import java.util.List;

import org.igfay.jfig.JFigException;

import uk.ljmu.metadata.utilities.MetadataUtilities;
import uk.ljmu.qudexapps.xmllib.exceptions.FoxmlException;
import uk.ljmu.qudexapps.xmllib.services.UpdateOperations;
import uk.ljmu.qudexapps.xmllib.services.UpdateOperationsImpl;
/**
 * MAIN program to test some methods
 * 
 * @author agustinamartinez
 *
 */
public class Main {

	/**
	 * @param args
	 * @throws FoxmlException 
	 * @throws JFigException 
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws FoxmlException, JFigException, FileNotFoundException {
		//QudexFoxmlService qudexService = new QudexFoxmlServiceImpl(MetadataUtilities.MIMETYPES_MAP.get("excel"), true);
		UpdateOperations qudexService = new UpdateOperationsImpl(MetadataUtilities.MIMETYPES_MAP.get("excel"), true);
		InputStream isExcel = new FileInputStream(new File("/Eclipse/phd-ws/qudex-xml-lib/src/main/resources/test-update-collections.xls"));
		List<String> colsList = new ArrayList<String>();
		colsList.add("qudex:525");
		qudexService.updateCollections(isExcel);
	}
}
