/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.ljmu.qudexapps.xmllib.model;

import java.io.Serializable;
import java.util.LinkedHashMap;

/**
 * Class that manages a map of the spreadsheet (Identifier - Column Map pairs)
 * 
 * @author agustinamartinez
 *
 */
public class SpreadsheetMap implements Serializable
{
	/**
	 * Generated Serial Version
	 */
	private static final long serialVersionUID = 6877759139292974232L;
	public LinkedHashMap<String, ColumnMap> globalMap;

	/**
	 * @return the globalMap
	 */
	public LinkedHashMap<String, ColumnMap> getGlobalMap() {
		return globalMap;
	}
	/**
	 * Set the map structure
	 * @param elem map structure
	 */
	public void setGlobalMap(LinkedHashMap<String, ColumnMap> elem)
	{
		globalMap = elem;
	}
	/**
	 * Constructor
	 */
	public SpreadsheetMap()
	{
		this.globalMap = new LinkedHashMap<String, ColumnMap>();
	}
}
