/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.ljmu.qudexapps.manager.services;

import org.directwebremoting.annotations.RemoteMethod;
import org.directwebremoting.annotations.RemoteProxy;
import org.springframework.beans.factory.annotation.Autowired;

import uk.ljmu.qudexapps.manager.services.SpreadsheetService;

@RemoteProxy(name="dwrService")
public class DwrService {
    	@Autowired
	private SpreadsheetService spService;

	/**
	 * @param spService
	 *            the spService to set
	 */
	public void setSpService(SpreadsheetService spService) {
		this.spService = spService;
	}

	/**
	 * @return the spService
	 */
	public SpreadsheetService getSpService() {
		return spService;
	}
	@RemoteMethod
	public String getActualProgress() {		
		return this.spService.getProgress();
	}
}
