/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.ljmu.qudexapps.manager.utilities;

import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;

/**
 * Static convenience methods for common web-related tasks.
 */
public final class WebUtils {
    /**
     * 
     * @param aEmailAddress
     * @return
     */
    public static boolean isValidEmailAddress(String aEmailAddress) {
	if (aEmailAddress == null)
	    return false;
	boolean result = true;
	try {
	    InternetAddress emailAddr = new InternetAddress(aEmailAddress);
	    emailAddr.validate();
	    result = true;
	} catch (AddressException ex) {
	    result = false;
	}
	return result;
    }
}