/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.ljmu.qudexapps.swfspreadsheet.controllers;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.exception.ExceptionUtils;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.webflow.conversation.NoSuchConversationException;
import org.springframework.webflow.core.FlowException;
import org.springframework.webflow.execution.FlowExecutionOutcome;
import org.springframework.webflow.execution.repository.NoSuchFlowExecutionException;
import org.springframework.webflow.mvc.servlet.AbstractFlowHandler;

public class GenerateFlowHandler extends AbstractFlowHandler{

    @Override
    public String handleExecutionOutcome(FlowExecutionOutcome outcome, HttpServletRequest request,
	    HttpServletResponse response) {
	if (outcome.getId().equals("displayError"))
	    return "error/generateError";
	else return "/intro";    	
    }

    @Override
    public String handleException(FlowException e, HttpServletRequest request, HttpServletResponse response) {
	
	Throwable rootException = ExceptionUtils.getRootCause(e);
	
	if (rootException instanceof NoSuchFlowExecutionException || 
		rootException instanceof NoSuchConversationException) {
	    return "/metadata-flow";
	} else {
	    return handleOtherException((IOException) rootException, request);
	} 
    }

    @ExceptionHandler(Exception.class)
    public String handleOtherException(Exception ex, HttpServletRequest request) {
	return "error/defaultError";
    }
}
