/*
 * Copyright 2013 Agustina Martinez-Garcia

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package uk.ljmu.qudexapps.swfspreadsheet.domain;

import java.io.Serializable;

public class VocabularyElement implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -2606194682183386872L;
	private String name;
	private String label;
	private String type;
	private String comment;
	private boolean selected;
	private boolean hidden;
	/**
	 * Is the element optional or mandatory within Qudex Collections or Documents spreadsheet
	 */
	private boolean optional;
	
	public void setLabel(String label) {
		this.label = label;
	}
	public String getLabel() {
		return label;
	}
	/**
	 * @return the comment
	 */
	public String getComment() {
		return comment;
	}
	/**
	 * @param comment the comment to set
	 */
	public void setComment(String comment) {
		this.comment = comment;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getName() {
		return name;
	}
	public void setType(String type) {
		this.type = type;
	}
	public String getType() {
		return type;
	}
	public void setSelected(boolean selected) {
		this.selected = selected;
	}
	public boolean isSelected() {
		return selected;
	}
	/**
	 * @param optional the optional to set
	 */
	public void setOptional(boolean optional) {
	    this.optional = optional;
	}
	/**
	 * @return the optional
	 */
	public boolean isOptional() {
	    return optional;
	}
	
	public VocabularyElement() {
	    this.optional = true;
	}
	/**
	 * @param hidden the hidden to set
	 */
	public void setHidden(boolean hidden) {
	    this.hidden = hidden;
	}
	/**
	 * @return the hidden
	 */
	public boolean isHidden() {
	    return hidden;
	}
}
